zenilib: zenilib/jni/external/freetype2/src/base/ftobjs.c File Reference

zenilib 0.5.3.0

- Main Page
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
Macros | Functions
ftobjs.c File Reference
`#include <ft2build.h>`
`#include <FT_LIST_H>`
`#include <FT_OUTLINE_H>`
`#include <FT_INTERNAL_VALIDATE_H>`
`#include <FT_INTERNAL_OBJECTS_H>`
`#include <FT_INTERNAL_DEBUG_H>`
`#include <FT_INTERNAL_RFORK_H>`
`#include <FT_INTERNAL_STREAM_H>`
`#include <FT_INTERNAL_SFNT_H>`
`#include <FT_TRUETYPE_TABLES_H>`
`#include <FT_TRUETYPE_TAGS_H>`
`#include <FT_TRUETYPE_IDS_H>`
`#include <FT_SERVICE_SFNT_H>`
`#include <FT_SERVICE_POSTSCRIPT_NAME_H>`
`#include <FT_SERVICE_GLYPH_DICT_H>`
`#include <FT_SERVICE_TT_CMAP_H>`
`#include <FT_SERVICE_KERNING_H>`
`#include <FT_SERVICE_TRUETYPE_ENGINE_H>`

Go to the source code of this file.

## Macros

#define | FREETYPE_VER_FIXED
#define | FT_COMPONENT trace_objs
#define | GRID_FIT_METRICS

## Functions

static void | destroy_charmaps (FT_Face face, FT_Memory memory)
static void | Destroy_Driver (FT_Driver driver)
static void | destroy_face (FT_Memory memory, FT_Face face, FT_Driver driver)
static void | Destroy_Module (FT_Module module)
static void | destroy_size (FT_Memory memory, FT_Size size, FT_Driver driver)
static FT_Error | find_unicode_charmap (FT_Face face)
static FT_CharMap | find_variant_selector_charmap (FT_Face face)
| FT_Activate_Size (FT_Size size)
| FT_Add_Module (FT_Library library, const FT_Module_Class *clazz)
static FT_Error | ft_add_renderer (FT_Module module)
| FT_Attach_File (FT_Face face, const char *filepathname)
| FT_Attach_Stream (FT_Face face, FT_Open_Args *parameters)
| FT_CMap_Done (FT_CMap cmap)
static void | ft_cmap_done_internal (FT_CMap cmap)
| FT_CMap_New (FT_CMap_Class clazz, FT_Pointer init_data, FT_CharMap charmap, FT_CMap *acmap)
| FT_Done_Face (FT_Face face)
| FT_Done_GlyphSlot (FT_GlyphSlot slot)
| FT_Done_Library (FT_Library library)
| FT_Done_Size (FT_Size size)
| FT_Face_GetCharsOfVariant (FT_Face face, FT_ULong variantSelector)
| FT_Face_GetCharVariantIndex (FT_Face face, FT_ULong charcode, FT_ULong variantSelector)
| FT_Face_GetCharVariantIsDefault (FT_Face face, FT_ULong charcode, FT_ULong variantSelector)
| FT_Face_GetVariantSelectors (FT_Face face)
| FT_Face_GetVariantsOfChar (FT_Face face, FT_ULong charcode)
| FT_Get_Char_Index (FT_Face face, FT_ULong charcode)
| FT_Get_Charmap_Index (FT_CharMap charmap)
| FT_Get_CMap_Format (FT_CharMap charmap)
| FT_Get_CMap_Language_ID (FT_CharMap charmap)
| FT_Get_First_Char (FT_Face face, FT_UInt *agindex)
| FT_Get_Glyph_Name (FT_Face face, FT_UInt glyph_index, FT_Pointer buffer, FT_UInt buffer_max)
| FT_Get_Kerning (FT_Face face, FT_UInt left_glyph, FT_UInt right_glyph, FT_UInt kern_mode, FT_Vector *akerning)
| FT_Get_Module (FT_Library library, const char *module_name)
| FT_Get_Module_Interface (FT_Library library, const char *mod_name)
| FT_Get_Name_Index (FT_Face face, FT_String *glyph_name)
| FT_Get_Next_Char (FT_Face face, FT_ULong charcode, FT_UInt *agindex)
| FT_Get_Postscript_Name (FT_Face face)
| FT_Get_Renderer (FT_Library library, FT_Glyph_Format format)
| FT_Get_Sfnt_Table (FT_Face face, FT_Sfnt_Tag tag)
| FT_Get_SubGlyph_Info (FT_GlyphSlot glyph, FT_UInt sub_index, FT_Int *p_index, FT_UInt *p_flags, FT_Int *p_arg1, FT_Int *p_arg2, FT_Matrix *p_transform)
| FT_Get_Track_Kerning (FT_Face face, FT_Fixed point_size, FT_Int degree, FT_Fixed *akerning)
| FT_Get_TrueType_Engine_Type (FT_Library library)
| ft_glyphslot_alloc_bitmap (FT_GlyphSlot slot, FT_ULong size)
static void | ft_glyphslot_clear (FT_GlyphSlot slot)
static void | ft_glyphslot_done (FT_GlyphSlot slot)
| ft_glyphslot_free_bitmap (FT_GlyphSlot slot)
static void | ft_glyphslot_grid_fit_metrics (FT_GlyphSlot slot, FT_Bool vertical)
static FT_Error | ft_glyphslot_init (FT_GlyphSlot slot)
| ft_glyphslot_set_bitmap (FT_GlyphSlot slot, FT_Byte *buffer)
| FT_Library_Version (FT_Library library, FT_Int *amajor, FT_Int *aminor, FT_Int *apatch)
| FT_Load_Char (FT_Face face, FT_ULong char_code, FT_Int32 load_flags)
| FT_Load_Glyph (FT_Face face, FT_UInt glyph_index, FT_Int32 load_flags)
| FT_Load_Sfnt_Table (FT_Face face, FT_ULong tag, FT_Long offset, FT_Byte *buffer, FT_ULong *length)
static FT_Renderer | ft_lookup_glyph_renderer (FT_GlyphSlot slot)
| FT_Lookup_Renderer (FT_Library library, FT_Glyph_Format format, FT_ListNode *node)
| FT_Match_Size (FT_Face face, FT_Size_Request req, FT_Bool ignore_width, FT_ULong *size_index)
| ft_module_get_service (FT_Module module, const char *service_id)
| FT_New_Face (FT_Library library, const char *pathname, FT_Long face_index, FT_Face *aface)
| FT_New_GlyphSlot (FT_Face face, FT_GlyphSlot *aslot)
| FT_New_Library (FT_Memory memory, FT_Library *alibrary)
| FT_New_Memory_Face (FT_Library library, const FT_Byte *file_base, FT_Long file_size, FT_Long face_index, FT_Face *aface)
| FT_New_Size (FT_Face face, FT_Size *asize)
| FT_Open_Face (FT_Library library, const FT_Open_Args *args, FT_Long face_index, FT_Face *aface)
static void | ft_recompute_scaled_metrics (FT_Face face, FT_Size_Metrics *metrics)
| FT_Reference_Face (FT_Face face)
| FT_Reference_Library (FT_Library library)
| FT_Remove_Module (FT_Library library, FT_Module module)
static void | ft_remove_renderer (FT_Module module)
| FT_Render_Glyph (FT_GlyphSlot slot, FT_Render_Mode render_mode)
| FT_Render_Glyph_Internal (FT_Library library, FT_GlyphSlot slot, FT_Render_Mode render_mode)
| FT_Request_Metrics (FT_Face face, FT_Size_Request req)
| FT_Request_Size (FT_Face face, FT_Size_Request req)
| FT_Select_Charmap (FT_Face face, FT_Encoding encoding)
| FT_Select_Metrics (FT_Face face, FT_ULong strike_index)
| FT_Select_Size (FT_Face face, FT_Int strike_index)
| ft_service_list_lookup (FT_ServiceDesc service_descriptors, const char *service_id)
| FT_Set_Char_Size (FT_Face face, FT_F26Dot6 char_width, FT_F26Dot6 char_height, FT_UInt horz_resolution, FT_UInt vert_resolution)
| FT_Set_Charmap (FT_Face face, FT_CharMap charmap)
static void | ft_set_current_renderer (FT_Library library)
| FT_Set_Debug_Hook (FT_Library library, FT_UInt hook_index, FT_DebugHook_Func debug_hook)
| FT_Set_Pixel_Sizes (FT_Face face, FT_UInt pixel_width, FT_UInt pixel_height)
| FT_Set_Renderer (FT_Library library, FT_Renderer renderer, FT_UInt num_params, FT_Parameter *parameters)
| FT_Set_Transform (FT_Face face, FT_Matrix *matrix, FT_Vector *delta)
| FT_Sfnt_Table_Info (FT_Face face, FT_UInt table_index, FT_ULong *tag, FT_ULong *length)
| FT_Stream_Free (FT_Stream stream, FT_Int external)
| FT_Stream_New (FT_Library library, const FT_Open_Args *args, FT_Stream *astream)
| ft_synthesize_vertical_metrics (FT_Glyph_Metrics *metrics, FT_Pos advance)
| ft_validator_error (FT_Validator valid, FT_Error error)
| ft_validator_init (FT_Validator valid, const FT_Byte *base, const FT_Byte *limit, FT_ValidationLevel level)
| ft_validator_run (FT_Validator valid)
static FT_Error | open_face (FT_Driver driver, FT_Stream stream, FT_Long face_index, FT_Int num_params, FT_Parameter *params, FT_Face *aface)

## Macro Definition Documentation

#define FREETYPE_VER_FIXED

Value:
( ( (FT_Long)FREETYPE_MAJOR << 16 ) | \
FREETYPE_MINOR )
FREETYPE_MINOR
#define FREETYPE_MINOR
Definition: freetype.h:3836
FT_Long
signed long FT_Long
Definition: fttypes.h:238
FREETYPE_MAJOR
#define FREETYPE_MAJOR
Definition: freetype.h:3835

Referenced by FT_Add_Module().

#define FT_COMPONENT trace_objs

Definition at line 218 of file ftobjs.c.

#define GRID_FIT_METRICS

Definition at line 43 of file ftobjs.c.

## Function Documentation

static void destroy_charmaps | ( | FT_Face | face,
|  | FT_Memory | memory
| ) |  |

static

Definition at line 851 of file ftobjs.c.

References FT_FaceRec_::charmaps, cmap, FT_CMAP, ft_cmap_done_internal(), FT_FREE, NULL, and FT_FaceRec_::num_charmaps.

Referenced by destroy_face(), and open_face().

static void Destroy_Driver | ( | FT_Driver | driver | ) |

static

Definition at line 928 of file ftobjs.c.

References destroy_face(), FT_DriverRec_::faces_list, FT_DRIVER_USES_OUTLINES, FT_GlyphLoader_Done(), FT_List_Finalize(), FT_DriverRec_::glyph_loader, FT_ModuleRec_::memory, and FT_DriverRec_::root.

Referenced by Destroy_Module().

static void destroy_face | ( | FT_Memory | memory,
|  | FT_Face | face,
|  | FT_Driver | driver
| ) |  |

static

Definition at line 877 of file ftobjs.c.

References FT_FaceRec_::autohint, FT_DriverRec_::clazz, FT_Generic_::data, destroy_charmaps(), destroy_size(), FT_Driver_ClassRec_::done_face, FT_FaceRec_::face_flags, FT_Generic_::finalizer, FT_Done_GlyphSlot(), FT_FACE_FLAG_EXTERNAL_STREAM, FT_FREE, FT_List_Finalize(), FT_Stream_Free(), FT_FaceRec_::generic, FT_FaceRec_::glyph, FT_FaceRec_::internal, FT_FaceRec_::size, FT_FaceRec_::sizes_list, and FT_FaceRec_::stream.

Referenced by Destroy_Driver(), and FT_Done_Face().

static void Destroy_Module | ( | FT_Module | module | ) |

static

Definition at line 4098 of file ftobjs.c.

References FT_LibraryRec_::auto_hinter, FT_ModuleRec_::clazz, Destroy_Driver(), FT_DRIVER, FT_FREE, FT_MODULE_IS_DRIVER, FT_MODULE_IS_RENDERER, ft_remove_renderer(), FT_ModuleRec_::library, FT_ModuleRec_::memory, and FT_Module_Class_::module_done.

Referenced by FT_Done_Library(), and FT_Remove_Module().

static void destroy_size | ( | FT_Memory | memory,
|  | FT_Size | size,
|  | FT_Driver | driver
| ) |  |

static

Definition at line 829 of file ftobjs.c.

References FT_DriverRec_::clazz, FT_Driver_ClassRec_::done_size, FT_Generic_::finalizer, FT_FREE, FT_SizeRec_::generic, and FT_SizeRec_::internal.

Referenced by destroy_face(), and FT_Done_Size().

static FT_Error find_unicode_charmap | ( | FT_Face | face | ) |

static

Definition at line 956 of file ftobjs.c.

References FT_FaceRec_::charmap, FT_FaceRec_::charmaps, FT_ASSERT, FT_Err_Ok, FT_ERROR, FT_MAX_CHARMAP_CACHEABLE, FT_FaceRec_::num_charmaps, TT_APPLE_ID_UNICODE_32, TT_MS_ID_UCS_4, TT_PLATFORM_APPLE_UNICODE, and TT_PLATFORM_MICROSOFT.

Referenced by FT_Select_Charmap(), and open_face().

static FT_CharMap find_variant_selector_charmap | ( | FT_Face | face | ) |

static

Definition at line 1060 of file ftobjs.c.

References FT_FaceRec_::charmaps, FT_ASSERT, FT_ERROR, FT_Get_CMap_Format(), FT_MAX_CHARMAP_CACHEABLE, NULL, FT_FaceRec_::num_charmaps, TT_APPLE_ID_VARIANT_SELECTOR, and TT_PLATFORM_APPLE_UNICODE.

Referenced by FT_Face_GetCharsOfVariant(), FT_Face_GetCharVariantIndex(), FT_Face_GetCharVariantIsDefault(), FT_Face_GetVariantSelectors(), and FT_Face_GetVariantsOfChar().

FT_Activate_Size | ( | FT_Size | size | ) |

Definition at line 3754 of file ftobjs.c.

References FT_FaceRec_::driver, FT_Err_Invalid_Argument, FT_Err_Ok, NULL, and FT_FaceRec_::size.

Referenced by ftc_scaler_lookup_size(), ftc_size_node_compare(), T42_Size_Init(), T42_Size_Request(), and T42_Size_Select().

FT_Add_Module | ( | FT_Library | library,
|  | const FT_Module_Class * | clazz
| ) |  |

Definition at line 4128 of file ftobjs.c.

References FT_ModuleRec_::clazz, FT_RendererRec_::clazz, FT_DriverRec_::clazz, error, FREETYPE_VER_FIXED, ft_add_renderer(), FT_ALLOC, FT_DRIVER, FT_DRIVER_USES_OUTLINES, FT_Err_Invalid_Argument, FT_Err_Ok, FT_FREE, FT_GLYPH_FORMAT_OUTLINE, FT_GlyphLoader_Done(), FT_GlyphLoader_New(), FT_MAX_MODULES, FT_MODULE_IS_DRIVER, FT_MODULE_IS_HINTER, FT_MODULE_IS_RENDERER, FT_Remove_Module(), FT_RENDERER, ft_strcmp, FT_Renderer_Class_::glyph_format, FT_DriverRec_::glyph_loader, if(), library, FT_ModuleRec_::library, FT_ModuleRec_::memory, FT_Module_Class_::module_name, FT_Module_Class_::module_version, FT_RendererRec_::raster, FT_Renderer_Class_::raster_class, and FT_Raster_Funcs_::raster_done.

Referenced by FT_Add_Default_Modules().

static FT_Error ft_add_renderer | ( | FT_Module | module | ) |

static

Definition at line 3856 of file ftobjs.c.

References FT_ModuleRec_::clazz, FT_RendererRec_::clazz, FT_ListNodeRec_::data, error, FT_FREE, FT_GLYPH_FORMAT_OUTLINE, FT_List_Add(), FT_NEW, FT_RENDERER, ft_set_current_renderer(), FT_Renderer_Class_::glyph_format, FT_RendererRec_::glyph_format, if(), FT_ModuleRec_::library, FT_LibraryRec_::memory, NULL, FT_RendererRec_::raster, FT_Renderer_Class_::raster_class, FT_Raster_Funcs_::raster_new, FT_RendererRec_::raster_render, FT_Raster_Funcs_::raster_render, Zeni::render(), FT_RendererRec_::render, FT_Renderer_Class_::render_glyph, and FT_LibraryRec_::renderers.

Referenced by FT_Add_Module().

FT_Attach_File | ( | FT_Face | face,
|  | const char * | filepathname
| ) |  |

Definition at line 2252 of file ftobjs.c.

References FT_Open_Args_::flags, FT_Attach_Stream(), FT_Err_Invalid_Argument, FT_OPEN_PATHNAME, NULL, FT_Open_Args_::pathname, and FT_Open_Args_::stream.

FT_Attach_Stream | ( | FT_Face | face,
|  | FT_Open_Args * | parameters
| ) |  |

Definition at line 2274 of file ftobjs.c.

References FT_Driver_ClassRec_::attach_file, FT_DriverRec_::clazz, error, FT_Bool, FT_OPEN_STREAM, FT_Stream_Free(), FT_Stream_New(), FT_ModuleRec_::library, and FT_DriverRec_::root.

Referenced by FT_Attach_File().

FT_CMap_Done | ( | FT_CMap | cmap | ) |

Definition at line 3190 of file ftobjs.c.

References FT_FaceRec_::charmap, FT_FaceRec_::charmaps, error, FT_CharMapRec_::face, ft_cmap_done_internal(), FT_FACE_MEMORY, FT_RENEW_ARRAY, i, j, NULL, and FT_FaceRec_::num_charmaps.

static void ft_cmap_done_internal | ( | FT_CMap | cmap | ) |

static

Definition at line 3175 of file ftobjs.c.

References FT_CMapRec_::charmap, FT_CMapRec_::clazz, FT_CMap_ClassRec_::done, FT_CharMapRec_::face, FT_FACE_MEMORY, and FT_FREE.

Referenced by destroy_charmaps(), FT_CMap_Done(), and FT_CMap_New().

FT_CMap_New | ( | FT_CMap_Class | clazz,
|  | FT_Pointer | init_data,
|  | FT_CharMap | charmap,
|  | FT_CMap * | acmap
| ) |  |

Definition at line 3236 of file ftobjs.c.

References FT_CMapRec_::charmap, FT_FaceRec_::charmaps, FT_CMapRec_::clazz, cmap, error, FT_ALLOC, ft_cmap_done_internal(), FT_Err_Invalid_Argument, FT_Err_Ok, FT_FACE_MEMORY, FT_RENEW_ARRAY, FT_CMap_ClassRec_::init, NULL, and FT_FaceRec_::num_charmaps.

Referenced by BDF_Face_Init(), cff_face_init(), FNT_Face_Init(), PCF_Face_Init(), pfr_face_init(), T1_Face_Init(), T42_Face_Init(), and tt_face_build_cmaps().

FT_Done_Face | ( | FT_Face | face | ) |

Definition at line 2329 of file ftobjs.c.

References destroy_face(), error, FT_DriverRec_::faces_list, FT_Err_Ok, FT_FREE, FT_List_Find(), FT_List_Remove(), FT_ModuleRec_::memory, and FT_DriverRec_::root.

Referenced by ExecuteTest(), FT_Done_Library(), FT_Open_Face(), ftc_face_node_done(), T42_Face_Done(), and TestFace().

FT_Done_GlyphSlot | ( | FT_GlyphSlot | slot | ) |

Definition at line 425 of file ftobjs.c.

References FT_GlyphSlotRec_::face, FT_Generic_::finalizer, FT_FREE, ft_glyphslot_done(), FT_GlyphSlotRec_::generic, FT_FaceRec_::glyph, FT_ModuleRec_::memory, FT_GlyphSlotRec_::next, NULL, and FT_DriverRec_::root.

Referenced by destroy_face(), and T42_GlyphSlot_Done().

FT_Done_Library | ( | FT_Library | library | ) |

Definition at line 4501 of file ftobjs.c.

References FT_ModuleRec_::clazz, FT_ListNodeRec_::data, Destroy_Module(), FT_Done_Face(), FT_DRIVER, FT_Err_Ok, FT_FACE, FT_FREE, FT_MODULE_FONT_DRIVER, FT_Remove_Module(), ft_strcmp, FT_TRACE0, FT_TRACE7, FT_ListRec_::head, m, FT_Module_Class_::module_flags, FT_Module_Class_::module_name, and NULL.

Referenced by FT_Done_FreeType().

FT_Done_Size | ( | FT_Size | size | ) |

Definition at line 2431 of file ftobjs.c.

References FT_ListNodeRec_::data, destroy_size(), FT_FaceRec_::driver, error, FT_Err_Ok, FT_FREE, FT_List_Find(), FT_List_Remove(), FT_ListRec_::head, FT_ModuleRec_::memory, FT_DriverRec_::root, FT_FaceRec_::size, and FT_FaceRec_::sizes_list.

Referenced by ftc_face_node_init(), ftc_scaler_lookup_size(), ftc_size_node_done(), ftc_size_node_reset(), T42_Face_Init(), and T42_Size_Done().

FT_Face_GetCharsOfVariant | ( | FT_Face | face,
|  | FT_ULong | variantSelector
| ) |  |

Definition at line 3515 of file ftobjs.c.

References FT_CMapRec_::clazz, find_variant_selector_charmap(), FT_CMAP, FT_FACE_MEMORY, FT_TRACE1, NULL, and FT_CMap_ClassRec_::variantchar_list.

FT_Face_GetCharVariantIndex | ( | FT_Face | face,
|  | FT_ULong | charcode,
|  | FT_ULong | variantSelector
| ) |  |

Definition at line 3370 of file ftobjs.c.

References FT_CMap_ClassRec_::char_var_index, FT_CMapRec_::clazz, find_variant_selector_charmap(), FT_CMAP, FT_TRACE1, and NULL.

FT_Face_GetCharVariantIsDefault | ( | FT_Face | face,
|  | FT_ULong | charcode,
|  | FT_ULong | variantSelector
| ) |  |

Definition at line 3413 of file ftobjs.c.

References FT_CMap_ClassRec_::char_var_default, FT_CMapRec_::clazz, find_variant_selector_charmap(), FT_CMAP, FT_TRACE1, and NULL.

FT_Face_GetVariantSelectors | ( | FT_Face | face | ) |

Definition at line 3454 of file ftobjs.c.

References FT_CMapRec_::clazz, find_variant_selector_charmap(), FT_CMAP, FT_FACE_MEMORY, NULL, and FT_CMap_ClassRec_::variant_list.

FT_Face_GetVariantsOfChar | ( | FT_Face | face,
|  | FT_ULong | charcode
| ) |  |

Definition at line 3481 of file ftobjs.c.

References FT_CMap_ClassRec_::charvariant_list, FT_CMapRec_::clazz, find_variant_selector_charmap(), FT_CMAP, FT_FACE_MEMORY, FT_TRACE1, and NULL.

FT_Get_Char_Index | ( | FT_Face | face,
|  | FT_ULong | charcode
| ) |  |

Definition at line 3290 of file ftobjs.c.

References FT_CMap_ClassRec_::char_index, FT_CMapRec_::clazz, cmap, FT_CMAP, and FT_TRACE1.

Referenced by af_face_globals_compute_script_coverage(), af_latin2_metrics_check_digits(), af_latin2_metrics_init_blues(), af_latin2_metrics_init_widths(), af_latin_metrics_check_digits(), af_latin_metrics_init_blues(), af_latin_metrics_init_widths(), FT_Get_First_Char(), FT_Load_Char(), FTC_CMapCache_Lookup(), and T1_Read_PFM().

FT_Get_Charmap_Index | ( | FT_CharMap | charmap | ) |

Definition at line 3147 of file ftobjs.c.

References FT_ASSERT, FT_ERROR, FT_MAX_CHARMAP_CACHEABLE, and i.

FT_Get_CMap_Format | ( | FT_CharMap | charmap | ) |

Definition at line 3730 of file ftobjs.c.

References cmap_info, TT_CMapInfo_::format, FT_FACE_FIND_SERVICE, and NULL.

Referenced by find_variant_selector_charmap(), and FT_Set_Charmap().

FT_Get_CMap_Language_ID | ( | FT_CharMap | charmap | ) |

Definition at line 3706 of file ftobjs.c.

References cmap_info, FT_FACE_FIND_SERVICE, TT_CMapInfo_::language, and NULL.

FT_Get_First_Char | ( | FT_Face | face,
|  | FT_UInt * | agindex
| ) |  |

Definition at line 3315 of file ftobjs.c.

References FT_Get_Char_Index(), and FT_Get_Next_Char().

FT_Get_Glyph_Name | ( | FT_Face | face,
|  | FT_UInt | glyph_index,
|  | FT_Pointer | buffer,
|  | FT_UInt | buffer_max
| ) |  |

Definition at line 3576 of file ftobjs.c.

References error, FT_Err_Invalid_Argument, FT_FACE_LOOKUP_SERVICE, and FT_HAS_GLYPH_NAMES.

Referenced by tt_check_single_notdef().

FT_Get_Kerning | ( | FT_Face | face,
|  | FT_UInt | left_glyph,
|  | FT_UInt | right_glyph,
|  | FT_UInt | kern_mode,
|  | FT_Vector * | akerning
| ) |  |

Definition at line 2963 of file ftobjs.c.

References FT_DriverRec_::clazz, error, FT_Err_Invalid_Argument, FT_Err_Ok, FT_KERNING_UNFITTED, FT_KERNING_UNSCALED, FT_MulDiv(), FT_MulFix(), FT_PIX_ROUND, and FT_Driver_ClassRec_::get_kerning.

Referenced by FT_Get_PFR_Kerning().

FT_Get_Module | ( | FT_Library | library,
|  | const char * | module_name
| ) |  |

Definition at line 4256 of file ftobjs.c.

References ft_strcmp.

Referenced by cff_get_interface(), cff_size_get_globals_funcs(), cff_slot_init(), cid_size_get_globals_funcs(), cid_slot_init(), FT_Get_Module_Interface(), FT_Get_TrueType_Engine_Type(), if(), T1_GlyphSlot_Init(), T1_Size_Get_Globals_Funcs(), T42_Driver_Init(), and tt_get_interface().

FT_Get_Module_Interface | ( | FT_Library | library,
|  | const char * | mod_name
| ) |  |

Definition at line 4284 of file ftobjs.c.

References FT_ModuleRec_::clazz, FT_Get_Module(), and FT_Module_Class_::module_interface.

Referenced by cff_face_init(), cid_face_init(), parse_afm(), sfnt_init_face(), T1_Face_Init(), T42_Face_Init(), and tt_face_init().

FT_Get_Name_Index | ( | FT_Face | face,
|  | FT_String * | glyph_name
| ) |  |

Definition at line 3550 of file ftobjs.c.

References FT_FACE_LOOKUP_SERVICE, and FT_HAS_GLYPH_NAMES.

FT_Get_Next_Char | ( | FT_Face | face,
|  | FT_ULong | charcode,
|  | FT_UInt * | agindex
| ) |  |

Definition at line 3339 of file ftobjs.c.

References FT_CMap_ClassRec_::char_next, FT_CMapRec_::clazz, cmap, and FT_CMAP.

Referenced by af_face_globals_compute_script_coverage(), and FT_Get_First_Char().

FT_Get_Postscript_Name | ( | FT_Face | face | ) |

Definition at line 3610 of file ftobjs.c.

References FT_FACE_LOOKUP_SERVICE, and NULL.

FT_Get_Renderer | ( | FT_Library | library,
|  | FT_Glyph_Format | format
| ) |  |

Definition at line 3934 of file ftobjs.c.

References FT_Lookup_Renderer().

FT_Get_Sfnt_Table | ( | FT_Face | face,
|  | FT_Sfnt_Tag | tag
| ) |  |

Definition at line 3639 of file ftobjs.c.

References FT_FACE_FIND_SERVICE, FT_IS_SFNT, and NULL.

Referenced by FT_Get_FSType_Flags().

FT_Get_SubGlyph_Info | ( | FT_GlyphSlot | glyph,
|  | FT_UInt | sub_index,
|  | FT_Int * | p_index,
|  | FT_UInt * | p_flags,
|  | FT_Int * | p_arg1,
|  | FT_Int * | p_arg2,
|  | FT_Matrix * | p_transform
| ) |  |

Definition at line 4721 of file ftobjs.c.

References FT_SubGlyphRec_::arg1, FT_SubGlyphRec_::arg2, error, FT_SubGlyphRec_::flags, FT_Err_Invalid_Argument, FT_SubGlyphRec_::index, and FT_SubGlyphRec_::transform.

FT_Get_Track_Kerning | ( | FT_Face | face,
|  | FT_Fixed | point_size,
|  | FT_Int | degree,
|  | FT_Fixed * | akerning
| ) |  |

Definition at line 3023 of file ftobjs.c.

References error, FT_Err_Invalid_Argument, FT_Err_Ok, and FT_FACE_FIND_SERVICE.

FT_Get_TrueType_Engine_Type | ( | FT_Library | library | ) |

Definition at line 4627 of file ftobjs.c.

References FT_Get_Module(), ft_module_get_service(), FT_SERVICE_ID_TRUETYPE_ENGINE, and FT_TRUETYPE_ENGINE_TYPE_NONE.

ft_glyphslot_alloc_bitmap | ( | FT_GlyphSlot | slot,
|  | FT_ULong | size
| ) |  |

Definition at line 295 of file ftobjs.c.

References error, FT_ALLOC, FT_FACE_MEMORY, FT_FREE, and FT_GLYPH_OWN_BITMAP.

Referenced by PCF_Glyph_Load(), and tt_sbit_decoder_alloc_bitmap().

static void ft_glyphslot_clear | ( | FT_GlyphSlot | slot | ) |

static

Definition at line 313 of file ftobjs.c.

References FT_GlyphSlotRec_::bitmap, FT_GlyphSlotRec_::bitmap_left, FT_GlyphSlotRec_::bitmap_top, FT_GlyphSlotRec_::control_data, FT_GlyphSlotRec_::control_len, FT_GlyphSlotRec_::format, ft_glyphslot_free_bitmap(), FT_ZERO, FT_GlyphSlotRec_::linearHoriAdvance, FT_GlyphSlotRec_::linearVertAdvance, FT_GlyphSlotRec_::lsb_delta, FT_GlyphSlotRec_::metrics, FT_GlyphSlotRec_::num_subglyphs, FT_GlyphSlotRec_::other, FT_GlyphSlotRec_::outline, FT_Bitmap_::pitch, FT_Bitmap_::pixel_mode, FT_Bitmap_::rows, FT_GlyphSlotRec_::rsb_delta, FT_GlyphSlotRec_::subglyphs, and FT_Bitmap_::width.

Referenced by FT_Load_Glyph().

static void ft_glyphslot_done | ( | FT_GlyphSlot | slot | ) |

static

Definition at line 345 of file ftobjs.c.

References FT_DriverRec_::clazz, FT_Driver_ClassRec_::done_slot, FT_FaceRec_::driver, FT_GlyphSlotRec_::face, FT_DRIVER_USES_OUTLINES, FT_FREE, FT_GlyphLoader_Done(), ft_glyphslot_free_bitmap(), FT_GlyphSlotRec_::internal, FT_Slot_InternalRec_::loader, FT_ModuleRec_::memory, and FT_DriverRec_::root.

Referenced by FT_Done_GlyphSlot(), and FT_New_GlyphSlot().

ft_glyphslot_free_bitmap | ( | FT_GlyphSlot | slot | ) |

Definition at line 263 of file ftobjs.c.

References FT_FACE_MEMORY, FT_FREE, FT_GLYPH_OWN_BITMAP, and NULL.

Referenced by ft_glyphslot_clear(), ft_glyphslot_done(), ft_glyphslot_set_bitmap(), and t42_glyphslot_clear().

static void ft_glyphslot_grid_fit_metrics | ( | FT_GlyphSlot | slot,
|  | FT_Bool | vertical
| ) |  |

static

Definition at line 518 of file ftobjs.c.

References FT_PIX_CEIL, FT_PIX_FLOOR, FT_PIX_ROUND, FT_Pos, and FT_GlyphSlotRec_::metrics.

Referenced by FT_Load_Glyph().

static FT_Error ft_glyphslot_init | ( | FT_GlyphSlot | slot | ) |

static

Definition at line 235 of file ftobjs.c.

References FT_DriverRec_::clazz, FT_FaceRec_::driver, error, FT_GlyphSlotRec_::face, FT_DRIVER_USES_OUTLINES, FT_Err_Ok, FT_GlyphLoader_New(), FT_NEW, FT_Driver_ClassRec_::init_slot, FT_GlyphSlotRec_::internal, FT_ModuleRec_::library, FT_GlyphSlotRec_::library, FT_ModuleRec_::memory, NULL, and FT_DriverRec_::root.

Referenced by FT_New_GlyphSlot().

ft_glyphslot_set_bitmap | ( | FT_GlyphSlot | slot,
|  | FT_Byte * | buffer
| ) |  |

Definition at line 283 of file ftobjs.c.

References FT_ASSERT, FT_GLYPH_OWN_BITMAP, and ft_glyphslot_free_bitmap().

Referenced by BDF_Glyph_Load().

FT_Library_Version | ( | FT_Library | library,
|  | FT_Int * | amajor,
|  | FT_Int * | aminor,
|  | FT_Int * | apatch
| ) |  |

Definition at line 4470 of file ftobjs.c.

FT_Load_Char | ( | FT_Face | face,
|  | FT_ULong | char_code,
|  | FT_Int32 | load_flags
| ) |  |

Definition at line 809 of file ftobjs.c.

References FT_Get_Char_Index(), and FT_Load_Glyph().

FT_Load_Glyph | ( | FT_Face | face,
|  | FT_UInt | glyph_index,
|  | FT_Int32 | load_flags
| ) |  |

Definition at line 563 of file ftobjs.c.

References FT_GlyphSlotRec_::advance, FT_LibraryRec_::auto_hinter, FT_ModuleRec_::clazz, FT_RendererRec_::clazz, FT_DriverRec_::clazz, error, FALSE, FT_GlyphSlotRec_::format, FT_Bool, FT_BOOL, FT_DRIVER_HAS_HINTER, FT_DRIVER_IS_SCALABLE, FT_DRIVER_USES_OUTLINES, FT_GLYPH_FORMAT_OUTLINE, ft_glyphslot_clear(), ft_glyphslot_grid_fit_metrics(), FT_HAS_FIXED_SIZES, FT_IS_SCALABLE, FT_IS_SFNT, FT_IS_TRICKY, FT_LOAD_FORCE_AUTOHINT, FT_LOAD_IGNORE_TRANSFORM, FT_LOAD_LINEAR_DESIGN, FT_LOAD_MONOCHROME, FT_LOAD_NO_AUTOHINT, FT_LOAD_NO_BITMAP, FT_LOAD_NO_HINTING, FT_LOAD_NO_RECURSE, FT_LOAD_NO_SCALE, FT_LOAD_RENDER, FT_LOAD_SBITS_ONLY, FT_LOAD_TARGET_MODE, FT_LOAD_VERTICAL_LAYOUT, ft_lookup_glyph_renderer(), FT_MulDiv(), FT_Outline_Check(), FT_Outline_Transform(), FT_Outline_Translate(), FT_Render_Glyph(), FT_RENDER_MODE_LIGHT, FT_RENDER_MODE_MONO, FT_RENDER_MODE_NORMAL, FT_TRACE5, FT_Vector_Transform(), library, FT_ModuleRec_::library, FT_GlyphSlotRec_::linearHoriAdvance, FT_GlyphSlotRec_::linearVertAdvance, FT_AutoHinter_ServiceRec_::load_glyph, FT_Driver_ClassRec_::load_glyph, TT_FaceRec_::max_profile, TT_MaxProfile_::maxSizeOfInstructions, FT_GlyphSlotRec_::metrics, FT_Module_Class_::module_interface, TT_FaceRec_::num_locations, FT_GlyphSlotRec_::outline, FT_DriverRec_::root, FT_Face_InternalRec_::transform_flags, FT_Renderer_Class_::transform_glyph, TRUE, FT_Vector_::x, FT_Size_Metrics_::x_scale, FT_Vector_::y, and FT_Size_Metrics_::y_scale.

Referenced by af_latin2_metrics_init_blues(), af_latin2_metrics_init_widths(), af_latin_metrics_init_blues(), af_latin_metrics_init_widths(), af_loader_load_g(), FT_Get_Advances(), FT_Load_Char(), ftc_basic_family_load_bitmap(), ftc_basic_family_load_glyph(), gxv_ctlPoint_validate(), gxv_prop_zero_advance_validate(), and TestFace().

FT_Load_Sfnt_Table | ( | FT_Face | face,
|  | FT_ULong | tag,
|  | FT_Long | offset,
|  | FT_Byte * | buffer,
|  | FT_ULong * | length
| ) |  |

Definition at line 3660 of file ftobjs.c.

References FT_FACE_FIND_SERVICE, FT_IS_SFNT, and NULL.

Referenced by gxv_load_table(), and otv_load_table().

static FT_Renderer ft_lookup_glyph_renderer | ( | FT_GlyphSlot | slot | ) |

static

Definition at line 3830 of file ftobjs.c.

References FT_LibraryRec_::cur_renderer, FT_GlyphSlotRec_::face, FT_GlyphSlotRec_::format, FT_FACE_LIBRARY, FT_Lookup_Renderer(), and FT_RendererRec_::glyph_format.

Referenced by FT_Load_Glyph().

FT_Lookup_Renderer | ( | FT_Library | library,
|  | FT_Glyph_Format | format,
|  | FT_ListNode * | node
| ) |  |

Definition at line 3788 of file ftobjs.c.

References FT_ListNodeRec_::data, FT_RENDERER, FT_RendererRec_::glyph_format, and FT_ListNodeRec_::next.

Referenced by FT_Get_Glyph(), FT_Get_Renderer(), ft_lookup_glyph_renderer(), FT_Outline_Render(), FT_Render_Glyph_Internal(), and ft_set_current_renderer().

FT_Match_Size | ( | FT_Face | face,
|  | FT_Size_Request | req,
|  | FT_Bool | ignore_width,
|  | FT_ULong * | size_index
| ) |  |

Definition at line 2479 of file ftobjs.c.

References FT_Err_Ok, FT_HAS_FIXED_SIZES, FT_PIX_ROUND, FT_REQUEST_HEIGHT, FT_REQUEST_WIDTH, FT_SIZE_REQUEST_TYPE_NOMINAL, i, FT_Bitmap_Size_::x_ppem, and FT_Bitmap_Size_::y_ppem.

Referenced by FT_Request_Size(), and tt_face_set_sbit_strike().

ft_module_get_service | ( | FT_Module | module,
|  | const char * | service_id
| ) |  |

Definition at line 4299 of file ftobjs.c.

References FT_ModuleRec_::clazz, FT_ASSERT, FT_Module_Class_::get_interface, FT_LibraryRec_::modules, NULL, and FT_LibraryRec_::num_modules.

Referenced by FT_Get_TrueType_Engine_Type(), and if().

FT_New_Face | ( | FT_Library | library,
|  | const char * | pathname,
|  | FT_Long | face_index,
|  | FT_Face * | aface
| ) |  |

Definition at line 1199 of file ftobjs.c.

References FT_Open_Args_::flags, FT_Err_Invalid_Argument, FT_Open_Face(), FT_OPEN_PATHNAME, NULL, FT_Open_Args_::pathname, and FT_Open_Args_::stream.

Referenced by ExecuteTest().

FT_New_GlyphSlot | ( | FT_Face | face,
|  | FT_GlyphSlot * | aslot
| ) |  |

Definition at line 376 of file ftobjs.c.

References FT_DriverRec_::clazz, error, FT_GlyphSlotRec_::face, FT_ALLOC, FT_Err_Invalid_Argument, FT_FREE, ft_glyphslot_done(), ft_glyphslot_init(), FT_TRACE4, FT_ModuleRec_::memory, FT_GlyphSlotRec_::next, NULL, FT_DriverRec_::root, and FT_Driver_ClassRec_::slot_object_size.

Referenced by FT_Open_Face(), and T42_GlyphSlot_Init().

FT_New_Library | ( | FT_Memory | memory,
|  | FT_Library * | alibrary
| ) |  |

Definition at line 4412 of file ftobjs.c.

References error, FREETYPE_MAJOR, FREETYPE_MINOR, FREETYPE_PATCH, FT_ALLOC, ft_debug_init(), FT_Err_Invalid_Argument, FT_Err_Ok, FT_FREE, FT_NEW, FT_RENDER_POOL_SIZE, library, FT_LibraryRec_::memory, NULL, FT_LibraryRec_::raster_pool, FT_LibraryRec_::raster_pool_size, FT_LibraryRec_::refcount, FT_LibraryRec_::version_major, FT_LibraryRec_::version_minor, and FT_LibraryRec_::version_patch.

Referenced by FT_Init_FreeType().

FT_New_Memory_Face | ( | FT_Library | library,
|  | const FT_Byte * | file_base,
|  | FT_Long | file_size,
|  | FT_Long | face_index,
|  | FT_Face * | aface
| ) |  |

Definition at line 1224 of file ftobjs.c.

References FT_Open_Args_::flags, FT_Err_Invalid_Argument, FT_Open_Face(), FT_OPEN_MEMORY, FT_Open_Args_::memory_base, FT_Open_Args_::memory_size, NULL, and FT_Open_Args_::stream.

FT_New_Size | ( | FT_Face | face,
|  | FT_Size * | asize
| ) |  |

Definition at line 2370 of file ftobjs.c.

References FT_DriverRec_::clazz, FT_ListNodeRec_::data, error, FT_SizeRec_::face, FT_ALLOC, FT_FREE, FT_List_Add(), FT_NEW, FT_Driver_ClassRec_::init_size, FT_SizeRec_::internal, and FT_Driver_ClassRec_::size_object_size.

Referenced by FT_Open_Face(), ftc_scaler_lookup_size(), and T42_Size_Init().

FT_Open_Face | ( | FT_Library | library,
|  | const FT_Open_Args * | args,
|  | FT_Long | face_index,
|  | FT_Face * | aface
| ) |  |

Definition at line 1994 of file ftobjs.c.

References FT_FaceRec_::available_sizes, FT_ListNodeRec_::data, FT_FaceRec_::driver, error, FT_FaceRec_::face_flags, FT_DriverRec_::faces_list, FT_Bool, FT_BOOL, FT_Done_Face(), FT_DRIVER, FT_Err_Invalid_Argument, FT_ERROR_BASE, FT_FACE_FLAG_EXTERNAL_STREAM, FT_HAS_FIXED_SIZES, FT_HAS_VERTICAL, FT_IS_SCALABLE, FT_List_Add(), FT_MODULE_IS_DRIVER, FT_NEW, FT_New_GlyphSlot(), FT_New_Size(), FT_OPEN_DRIVER, FT_OPEN_PARAMS, FT_OPEN_STREAM, ft_strcmp, FT_Stream_Free(), FT_Stream_New(), FT_Stream_Seek(), FT_TRACE4, FT_Bitmap_Size_::height, FT_FaceRec_::height, i, if(), FT_FaceRec_::internal, FT_FaceRec_::max_advance_height, NULL, FT_FaceRec_::num_fixed_sizes, open_face(), open_face_PS_from_sfnt_stream(), FT_FaceRec_::size, FT_Face_InternalRec_::transform_matrix, FT_Bitmap_Size_::x_ppem, FT_Matrix_::xx, and FT_Bitmap_Size_::y_ppem.

Referenced by FT_New_Face(), FT_New_Memory_Face(), and T42_Face_Init().

static void ft_recompute_scaled_metrics | ( | FT_Face | face,
|  | FT_Size_Metrics * | metrics
| ) |  |

static

Definition at line 2556 of file ftobjs.c.

References FT_FaceRec_::ascender, FT_Size_Metrics_::ascender, FT_FaceRec_::descender, FT_Size_Metrics_::descender, FT_MulFix(), FT_PIX_CEIL, FT_PIX_FLOOR, FT_PIX_ROUND, FT_FaceRec_::height, FT_Size_Metrics_::height, FT_Size_Metrics_::max_advance, FT_FaceRec_::max_advance_width, FT_Size_Metrics_::x_scale, and FT_Size_Metrics_::y_scale.

Referenced by FT_Request_Metrics(), and FT_Select_Metrics().

FT_Reference_Face | ( | FT_Face | face | ) |

Definition at line 2318 of file ftobjs.c.

References FT_Err_Ok.

FT_Reference_Library | ( | FT_Library | library | ) |

Definition at line 4401 of file ftobjs.c.

References FT_Err_Ok.

FT_Remove_Module | ( | FT_Library | library,
|  | FT_Module | module
| ) |  |

Definition at line 4346 of file ftobjs.c.

References Destroy_Module(), and FT_Err_Ok.

Referenced by FT_Add_Module(), and FT_Done_Library().

static void ft_remove_renderer | ( | FT_Module | module | ) |

static

Definition at line 3904 of file ftobjs.c.

References FT_RendererRec_::clazz, FT_FREE, FT_GLYPH_FORMAT_OUTLINE, FT_List_Find(), FT_List_Remove(), FT_RENDERER, ft_set_current_renderer(), FT_Renderer_Class_::glyph_format, FT_ModuleRec_::library, FT_LibraryRec_::memory, FT_RendererRec_::raster, FT_Renderer_Class_::raster_class, FT_Raster_Funcs_::raster_done, Zeni::render(), and FT_LibraryRec_::renderers.

Referenced by Destroy_Module().

FT_Render_Glyph | ( | FT_GlyphSlot | slot,
|  | FT_Render_Mode | render_mode
| ) |  |

Definition at line 4054 of file ftobjs.c.

References FT_Err_Invalid_Argument, FT_FACE_LIBRARY, FT_Render_Glyph_Internal(), and library.

Referenced by FT_Load_Glyph(), and TestFace().

FT_Render_Glyph_Internal | ( | FT_Library | library,
|  | FT_GlyphSlot | slot,
|  | FT_Render_Mode | render_mode
| ) |  |

Definition at line 3993 of file ftobjs.c.

References error, FT_Bool, FT_Err_Ok, FT_ERROR_BASE, FT_GLYPH_FORMAT_OUTLINE, FT_Lookup_Renderer(), FT_Set_Renderer(), NULL, and FT_RendererRec_::render.

Referenced by FT_Glyph_To_Bitmap(), and FT_Render_Glyph().

FT_Request_Metrics | ( | FT_Face | face,
|  | FT_Size_Request | req
| ) |  |

Definition at line 2637 of file ftobjs.c.

References FT_Size_Metrics_::ascender, FT_Size_Metrics_::descender, FT_DivFix(), FT_IS_SCALABLE, FT_MulDiv(), FT_MulFix(), ft_recompute_scaled_metrics(), FT_REQUEST_HEIGHT, FT_REQUEST_WIDTH, FT_SIZE_REQUEST_TYPE_BBOX, FT_SIZE_REQUEST_TYPE_CELL, FT_SIZE_REQUEST_TYPE_MAX, FT_SIZE_REQUEST_TYPE_NOMINAL, FT_SIZE_REQUEST_TYPE_REAL_DIM, FT_SIZE_REQUEST_TYPE_SCALES, FT_TRACE5, FT_ZERO, FT_Size_Metrics_::height, FT_Size_Metrics_::max_advance, FT_Size_Metrics_::x_ppem, FT_Size_Metrics_::x_scale, FT_Size_Metrics_::y_ppem, and FT_Size_Metrics_::y_scale.

Referenced by cff_size_request(), cid_size_request(), FT_Request_Size(), T1_Size_Request(), and tt_size_request().

FT_Request_Size | ( | FT_Face | face,
|  | FT_Size_Request | req
| ) |  |

Definition at line 2811 of file ftobjs.c.

References FT_Size_Metrics_::ascender, FT_Size_Metrics_::descender, error, FT_Err_Invalid_Argument, FT_Err_Ok, FT_HAS_FIXED_SIZES, FT_IS_SCALABLE, FT_Match_Size(), FT_Request_Metrics(), FT_Select_Size(), FT_SIZE_REQUEST_TYPE_MAX, FT_TRACE3, FT_TRACE5, FT_Size_Metrics_::height, FT_Size_Metrics_::max_advance, FT_Driver_ClassRec_::request_size, FT_Size_Metrics_::x_ppem, FT_Size_Metrics_::x_scale, FT_Size_Metrics_::y_ppem, and FT_Size_Metrics_::y_scale.

Referenced by FT_Set_Char_Size(), FT_Set_Pixel_Sizes(), and T42_Size_Request().

FT_Select_Charmap | ( | FT_Face | face,
|  | FT_Encoding | encoding
| ) |  |

Definition at line 3054 of file ftobjs.c.

References find_unicode_charmap(), FT_Err_Invalid_Argument, FT_ERROR, and FT_MAX_CHARMAP_CACHEABLE.

Referenced by af_face_globals_compute_script_coverage(), af_latin2_metrics_init(), af_latin_metrics_init(), and FTC_CMapCache_Lookup().

FT_Select_Metrics | ( | FT_Face | face,
|  | FT_ULong | strike_index
| ) |  |

Definition at line 2590 of file ftobjs.c.

References FT_Size_Metrics_::ascender, FT_Size_Metrics_::descender, FT_DivFix(), FT_IS_SCALABLE, ft_recompute_scaled_metrics(), FT_TRACE5, FT_Bitmap_Size_::height, FT_Size_Metrics_::height, FT_Size_Metrics_::max_advance, FT_Bitmap_Size_::x_ppem, FT_Size_Metrics_::x_ppem, FT_Size_Metrics_::x_scale, FT_Bitmap_Size_::y_ppem, FT_Size_Metrics_::y_ppem, and FT_Size_Metrics_::y_scale.

Referenced by BDF_Size_Select(), FNT_Size_Select(), FT_Select_Size(), and PCF_Size_Select().

FT_Select_Size | ( | FT_Face | face,
|  | FT_Int | strike_index
| ) |  |

Definition at line 2759 of file ftobjs.c.

References FT_Size_Metrics_::ascender, FT_Size_Metrics_::descender, error, FT_Err_Invalid_Argument, FT_Err_Ok, FT_HAS_FIXED_SIZES, FT_Select_Metrics(), FT_TRACE5, FT_Size_Metrics_::height, FT_Size_Metrics_::max_advance, FT_Driver_ClassRec_::select_size, FT_Size_Metrics_::x_ppem, FT_Size_Metrics_::x_scale, FT_Size_Metrics_::y_ppem, and FT_Size_Metrics_::y_scale.

Referenced by FT_Request_Size(), and T42_Size_Select().

ft_service_list_lookup | ( | FT_ServiceDesc | service_descriptors,
|  | const char * | service_id
| ) |  |

Definition at line 47 of file ftobjs.c.

References ft_strcmp, NULL, FT_ServiceDescRec_::serv_data, and FT_ServiceDescRec_::serv_id.

Referenced by bdf_driver_requester(), cff_get_interface(), cid_get_interface(), Get_Interface(), gxvalid_get_service(), otvalid_get_service(), pcf_driver_requester(), pfr_get_service(), T42_Get_Interface(), tt_get_interface(), and winfnt_get_service().

FT_Set_Char_Size | ( | FT_Face | face,
|  | FT_F26Dot6 | char_width,
|  | FT_F26Dot6 | char_height,
|  | FT_UInt | horz_resolution,
|  | FT_UInt | vert_resolution
| ) |  |

Definition at line 2887 of file ftobjs.c.

References FT_Request_Size(), FT_SIZE_REQUEST_TYPE_NOMINAL, FT_Size_RequestRec_::height, FT_Size_RequestRec_::horiResolution, FT_Size_RequestRec_::type, FT_Size_RequestRec_::vertResolution, and FT_Size_RequestRec_::width.

Referenced by ftc_scaler_lookup_size(), and TestFace().

FT_Set_Charmap | ( | FT_Face | face,
|  | FT_CharMap | charmap
| ) |  |

Definition at line 3105 of file ftobjs.c.

References FT_Err_Invalid_Argument, FT_ERROR, FT_Get_CMap_Format(), and FT_MAX_CHARMAP_CACHEABLE.

Referenced by af_face_globals_compute_script_coverage(), af_latin2_metrics_init(), af_latin_metrics_init(), FTC_CMapCache_Lookup(), and T1_Read_PFM().

static void ft_set_current_renderer | ( | FT_Library | library | ) |

static

Definition at line 3845 of file ftobjs.c.

References FT_LibraryRec_::cur_renderer, FT_GLYPH_FORMAT_OUTLINE, and FT_Lookup_Renderer().

Referenced by ft_add_renderer(), and ft_remove_renderer().

FT_Set_Debug_Hook | ( | FT_Library | library,
|  | FT_UInt | hook_index,
|  | FT_DebugHook_Func | debug_hook
| ) |  |

Definition at line 4613 of file ftobjs.c.

References sizeof().

FT_Set_Pixel_Sizes | ( | FT_Face | face,
|  | FT_UInt | pixel_width,
|  | FT_UInt | pixel_height
| ) |  |

Definition at line 2927 of file ftobjs.c.

References FT_Request_Size(), FT_SIZE_REQUEST_TYPE_NOMINAL, FT_Size_RequestRec_::height, FT_Size_RequestRec_::horiResolution, FT_Size_RequestRec_::type, FT_Size_RequestRec_::vertResolution, and FT_Size_RequestRec_::width.

Referenced by ftc_scaler_lookup_size().

FT_Set_Renderer | ( | FT_Library | library,
|  | FT_Renderer | renderer,
|  | FT_UInt | num_params,
|  | FT_Parameter * | parameters
| ) |  |

Definition at line 3946 of file ftobjs.c.

References error, FT_Err_Invalid_Argument, FT_Err_Ok, FT_GLYPH_FORMAT_OUTLINE, FT_List_Find(), and FT_List_Up().

Referenced by FT_Outline_Render(), and FT_Render_Glyph_Internal().

FT_Set_Transform | ( | FT_Face | face,
|  | FT_Matrix * | matrix,
|  | FT_Vector * | delta
| ) |  |

Definition at line 466 of file ftobjs.c.

References FT_Face_InternalRec_::transform_flags.

FT_Sfnt_Table_Info | ( | FT_Face | face,
|  | FT_UInt | table_index,
|  | FT_ULong * | tag,
|  | FT_ULong * | length
| ) |  |

Definition at line 3683 of file ftobjs.c.

References FT_FACE_FIND_SERVICE, FT_IS_SFNT, and NULL.

FT_Stream_Free | ( | FT_Stream | stream,
|  | FT_Int | external
| ) |  |

Definition at line 195 of file ftobjs.c.

References FT_FREE, and FT_Stream_Close().

Referenced by destroy_face(), FT_Attach_Stream(), and FT_Open_Face().

FT_Stream_New | ( | FT_Library | library,
|  | const FT_Open_Args * | args,
|  | FT_Stream * | astream
| ) |  |

Definition at line 127 of file ftobjs.c.

References error, FT_Err_Invalid_Argument, FT_FREE, FT_NEW, FT_OPEN_MEMORY, FT_OPEN_PATHNAME, FT_OPEN_STREAM, FT_Stream_Open(), FT_Stream_OpenMemory(), FT_StreamRec_::memory, NULL, FT_StreamRec_::pathname, and FT_StreamDesc_::pointer.

Referenced by FT_Attach_Stream(), and FT_Open_Face().

ft_synthesize_vertical_metrics | ( | FT_Glyph_Metrics * | metrics,
|  | FT_Pos | advance
| ) |  |

Definition at line 2530 of file ftobjs.c.

References FT_Pos.

Referenced by BDF_Glyph_Load(), cff_slot_load(), cid_slot_load_glyph(), FNT_Load_Glyph(), PCF_Glyph_Load(), and T1_Load_Glyph().

ft_validator_error | ( | FT_Validator | valid,
|  | FT_Error | error
| ) |  |

Definition at line 94 of file ftobjs.c.

References error, ft_jmp_buf, and ft_longjmp.

ft_validator_init | ( | FT_Validator | valid,
|  | const FT_Byte * | base,
|  | const FT_Byte * | limit,
|  | FT_ValidationLevel | level
| ) |  |

Definition at line 71 of file ftobjs.c.

References FT_Err_Ok.

Referenced by classic_kern_validate(), otv_validate(), and tt_face_build_cmaps().

ft_validator_run | ( | FT_Validator | valid | ) |

Definition at line 84 of file ftobjs.c.

References FT_UNUSED.

static FT_Error open_face | ( | FT_Driver | driver,
|  | FT_Stream | stream,
|  | FT_Long | face_index,
|  | FT_Int | num_params,
|  | FT_Parameter * | params,
|  | FT_Face * | aface
| ) |  |

static

Definition at line 1108 of file ftobjs.c.

References FT_DriverRec_::clazz, destroy_charmaps(), FT_Driver_ClassRec_::done_face, FT_FaceRec_::driver, error, FT_Driver_ClassRec_::face_object_size, find_unicode_charmap(), FT_ALLOC, FT_FREE, FT_NEW, FT_PARAM_TAG_INCREMENTAL, i, FT_Driver_ClassRec_::init_face, FT_FaceRec_::internal, FT_ModuleRec_::memory, FT_FaceRec_::memory, NULL, FT_DriverRec_::root, and FT_FaceRec_::stream.

Referenced by FT_Open_Face().